package edu.mit.harold.icollections;

import java.util.Collection;

/**
 * 
 * An immutable collection of non-null elements of type E.
 * 
 * @author harold
 *
 * @param <E>
 */
public interface ICollection<E> extends Collection<E> {
	/**
	 * @param e non-null
	 * @return a collection which contains e and all of the elements of this
	 */
	public ICollection<E> plus(E e);

	/**
	 * @param list contains no null elements
	 * @return a collection which contains all of the elements of list and this
	 */
	public ICollection<E> plusAll(Collection<? extends E> list);
	
	/**
	 * @param e
	 * @return this with a single instance of e removed, if e is in this
	 */
	public ICollection<E> minus(Object e);
	
	/**
	 * @param list
	 * @return this with all elements of list completely removed
	 */
	public ICollection<E> minusAll(Collection<?> list);
	
	// TODO public ICollection<E> retainingAll(Collection<?> list);
}
